﻿Type=StaticCode
Version=1.8
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@
'Keyboard code module
'See: <link>https://www.arduino.cc/en/Reference/MouseKeyboard|https://www.arduino.cc/en/Reference/MouseKeyboard</link>
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Private pressarg As Byte = 0	'ignore
End Sub

Public Sub Begin
	RunNative("begin", Null)
End Sub

Public Sub End
	RunNative("end", Null)
End Sub

Public Sub ReleaseAll
	RunNative("releaseAll", Null)
End Sub

Public Sub Release(char As Byte)
	pressarg = char
	RunNative("release", Null)
End Sub

Public Sub Press(char As String)
	pressarg = char.GetBytes(0)
	RunNative("press", Null)
End Sub

'For pressing the raw ASCII codes (useful for special keys)
'see: <link>https://www.arduino.cc/en/Reference/KeyboardModifiers|https://www.arduino.cc/en/Reference/KeyboardModifiers</link>
Public Sub Press2(b As Byte)
	pressarg = b
	RunNative("press", Null)
End Sub

Public Sub Print(printString As String)
	For j = 0 To printString.Length-1
		pressarg = printString.GetBytes(j)
		RunNative("print", Null)
	Next
	
End Sub

Public Sub PrintLn(printString As String)
	For j = 0 To printString.Length-1
		pressarg = printString.GetBytes(j)
		RunNative("print", Null)
	Next
	RunNative("println", Null)
End Sub

Public Sub Write(char As String)
	pressarg = char.GetBytes(0)
	RunNative("write", Null)
End Sub

'For pressing and releasing the raw ASCII codes (useful for special keys)
'see: <link>https://www.arduino.cc/en/Reference/KeyboardModifiers|https://www.arduino.cc/en/Reference/KeyboardModifiers</link>
Public Sub Write2(b As Byte)
	pressarg = b
	RunNative("write", Null)
End Sub


#If C
#include <Keyboard.h>

void begin(B4R::Object* o) {Keyboard.begin();}
void end(B4R::Object* o) {Keyboard.end();}
void releaseAll(B4R::Object* o) {Keyboard.releaseAll();}
void release(B4R::Object* o) {Keyboard.release(b4r_keyboard::_pressarg);}
void press(B4R::Object* o) {Keyboard.press(b4r_keyboard::_pressarg);}
void print(B4R::Object* o) {Keyboard.print((char)b4r_keyboard::_pressarg);}
void println(B4R::Object* o) {Keyboard.println();}
void write(B4R::Object* o) {Keyboard.write(b4r_keyboard::_pressarg);}
#End If

