﻿Type=StaticCode
Version=1.8
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@
'Mouse code module
'See: <link>https://www.arduino.cc/en/Reference/MouseKeyboard|https://www.arduino.cc/en/Reference/MouseKeyboard</link>
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Private pressarg As Byte = 0	'ignore
	Private mMOUSE_LEFT As Byte
	Private mMOUSE_RIGHT As Byte
	Private mMOUSE_MIDDLE As Byte
	Private x, y, w As Short
	Private lastBool As Boolean = False
End Sub

Public Sub Begin
	RunNative("mbegin", Null)
End Sub

Public Sub End
	RunNative("mend", Null)
End Sub

Public Sub Release(char As Byte)
	pressarg = char
	RunNative("mrelease", Null)
End Sub

Public Sub Move(xVal As Short, yVal As Short, Wheel As Short)
	x = xVal
	y = yVal
	w = Wheel
	RunNative("mmove", Null)
End Sub

Public Sub Press(MouseButton As Byte)
	pressarg = MouseButton
	RunNative("mpress", Null)
End Sub

Public Sub IsPressed(MouseButton As Byte) As Boolean
	pressarg = MouseButton
	RunNative("mispressed", Null)
	Return lastBool
End Sub

Public Sub MOUSE_LEFT As Byte
	Return mMOUSE_LEFT
End Sub

Public Sub MOUSE_RIGHT As Byte
	Return mMOUSE_RIGHT
End Sub

Public Sub MOUSE_MIDDLE As Byte
	Return mMOUSE_MIDDLE
End Sub

#If C
#include <Mouse.h>

void mbegin(B4R::Object* o) 
{
	Mouse.begin();
	b4r_mouse::_mmouse_left = MOUSE_LEFT;
	b4r_mouse::_mmouse_right = MOUSE_RIGHT;
	b4r_mouse::_mmouse_middle = MOUSE_MIDDLE;
}
void mend(B4R::Object* o) {Mouse.end();}
void mmove(B4R::Object* o) {Mouse.move(b4r_mouse::_x,b4r_mouse::_y,b4r_mouse::_w);}
void mrelease(B4R::Object* o) {Mouse.release(b4r_mouse::_pressarg);}
void mpress(B4R::Object* o) {Mouse.press(b4r_mouse::_pressarg);}
void mispressed(B4R::Object* o) {b4r_mouse::_lastbool = Mouse.isPressed(b4r_mouse::_pressarg);}
#End If