﻿Type=StaticCode
Version=1.8
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@
'Robo code module
'Uses the jAWTRobot library's syntax to enable Arduino Keyboard Mouse control.
'See: <link>https://b4x.com/android/forum/threads/jawtrobot-invoke-keyboard-and-mouse-events-etc.55832/|https://b4x.com/android/forum/threads/jawtrobot-invoke-keyboard-and-mouse-events-etc.55832/</link>
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.
	Private pressarg As Byte = 0	'ignore
	Private mMOUSE_LEFT As Byte
	Private mMOUSE_RIGHT As Byte
	Private mMOUSE_MIDDLE As Byte
	Private x, y, w As Short
	Private lastBool As Boolean = False
	
	Private sKeys() As String = Array As String("back", "enter", "control", "meta", "shift", "alt", "delete", "tab", _
		"escape", "windows", "capslock", "left_arrow", "right_arrow", "up_arrow", "down_arrow", "home", "end", "page_up", "page_down")
		
	Private sKeyCodes() As Byte = Array As Byte(178, 176, 128, 131, 129, 130, 212, 179, 177, 131, 193, 216, 215, 218, 217, 210, 213, 211, 214)
	
	RunNative("rkbegin", Null)
	RunNative("rmbegin", Null)
End Sub

'Presses and releases meta_c (suitable for Macs)
Public Sub RobotCopyMac
	pressarg = 131
	RunNative("rkpress", Null)
	pressarg = "c".GetBytes(0)
	RunNative("rkpress", Null)
	RunNative("rkreleaseAll", Null)
End Sub

'Presses and releases ctrl_c (suitable for Windows and Linux)
Public Sub RobotCopyWinLin
	pressarg = 128
	RunNative("rkpress", Null)
	pressarg = "c".GetBytes(0)
	RunNative("rkpress", Null)
	RunNative("rkreleaseAll", Null)
End Sub

'Presses and releases meta_x (suitable for Macs)
Public Sub RobotCutMac
	pressarg = 131
	RunNative("rkpress", Null)
	pressarg = "x".GetBytes(0)
	RunNative("rkpress", Null)
	RunNative("rkreleaseAll", Null)
End Sub

'Presses and releases ctrl_x (suitable for Windows and Linux)
Public Sub RobotCutWinLin
	pressarg = 128
	RunNative("rkpress", Null)
	pressarg = "x".GetBytes(0)
	RunNative("rkpress", Null)
	RunNative("rkreleaseAll", Null)
End Sub


'Presses and releases meta_v (suitable for Macs)
Public Sub RobotPaste2Mac
	pressarg = 131
	RunNative("rkpress", Null)
	pressarg = "v".GetBytes(0)
	RunNative("rkpress", Null)
	RunNative("rkreleaseAll", Null)
End Sub

'Presses and releases ctrl_x (suitable for Windows and Linux)
Public Sub RobotPaste2WinLin
	pressarg = 128
	RunNative("rkpress", Null)
	pressarg = "v".GetBytes(0)
	RunNative("rkpress", Null)
	RunNative("rkreleaseAll", Null)
End Sub

'Unlike in the jAWTRobot library, this types out printString
'Use RobotPaste2 to programmatically press ctrl_v or meta_v
Public Sub RobotPaste(printString As String)
	For j = 0 To printString.Length-1
		pressarg = printString.GetBytes(j)
		RunNative("rkprint", Null)
	Next
End Sub

Public Sub RobotDelay(ms As ULong)
	Delay(ms)
End Sub

'Presses the appropriate function key.
'For example, passing 3 will cause the F3 key to be pressed.
'Don't forget to release the function key.
'Only supports F1-F12
Public Sub RobotFunctionKeyPress(key As UInt)
	If key<1 Or key>11 Then Return
	pressarg = key + 193
	RunNative("rkpress", Null)
End Sub

'Only supports F1-F12
Public Sub RobotFunctionKeyRelease(key As UInt)
	If key<1 Or key>11 Then Return
	pressarg = key + 193
	RunNative("rkrelease", Null)
End Sub

'Returns the ASCII keycode (as a Byte) of the first character in char
'Mostly for diagnostic purposes.
Public Sub RobotKeyCode(char As String) As Byte
	Return char.GetBytes(0)
End Sub

'Presses the key for the first character in inString
'Don't forget to release the key
Public Sub RobotKeyPress(inString As String)
	pressarg = inString.GetBytes(0)
	RunNative("rkpress", Null)	
End Sub

Public Sub RobotKeyRelease(inString As String)
	pressarg = inString.GetBytes(0)
	RunNative("rkrelease", Null)
End Sub

'Types out inString. Essentially the same as RobotPaste
Public Sub RobotType(inString As String)
	For j = 0 To inString.Length-1
		pressarg = inString.GetBytes(j)
		RunNative("rkprint", Null)
	Next
End Sub

'Trigger a MousePressed event with button=1 for left, button=2 for right, button=3 for center
'Make sure to release the button.
Public Sub RobotMouseButtonPress(button As UInt)
	Select button
		Case 1
			pressarg = mMOUSE_LEFT
		Case 2
			pressarg = mMOUSE_RIGHT
		Case 3
			pressarg = mMOUSE_MIDDLE
	End Select
	RunNative("rmpress", Null)
End Sub

'Trigger a MouseReleased event with button=1 for left, button=2 for right, button=3 for center
Public Sub RobotMouseButtonRelease(button As UInt)
	Select button
		Case 1
			pressarg = mMOUSE_LEFT
		Case 2
			pressarg = mMOUSE_RIGHT
		Case 3
			pressarg = mMOUSE_MIDDLE
	End Select
	RunNative("rmrelease", Null)
End Sub

'Scrolls the Mouse Wheel by dir.
'Negative numbers scroll up, positive numbers scroll down
Public Sub RobotMouseWheel(dir As Int)
	x = 0
	y = 0
	w = -1*dir
	RunNative("rmmove", Null)
End Sub

Public Sub RobotMouseMoveBy(xdiff As Int, ydiff As Int)
	x = xdiff
	y = ydiff
	w = 0
	RunNative("rmmove", Null)
End Sub

'Programmatic press and release for the first character of inString
Public Sub RobotSingleStrike(inString As String)
	pressarg = inString.GetBytes(0)
	RunNative("rkwrite", Null)
End Sub

Public Sub RobotSingleStrikeKeyCode(keycode As Byte)
	pressarg = keycode
	RunNative("rkwrite", Null)
End Sub

'Supports the following: back, enter, control, meta, shift, alt, delete, tab,
'escape, windows, capslock, left_arrow, right_arrow, up_arrow, down_arrow,
'home, end, page_up, page_down.
'Make sure to release the key.
Public Sub RobotSpecialKeyPress(specialKey As String)
	Dim index As Int = ArrayIndexOf(specialKey)
	If index==-1 Then Return
	pressarg = sKeyCodes(index)
	RunNative("rkpress", Null)
End Sub

'Supports the following: back, enter, control, meta, shift, alt, delete, tab,
'escape, windows, capslock, left_arrow, right_arrow, up_arrow, down_arrow,
'home, end, page_up, page_down.
'Make sure to release the key.
Public Sub RobotSpecialKeyRelease(specialKey As String)
	Dim index As Int = ArrayIndexOf(specialKey)
	If index==-1 Then Return
	pressarg = sKeyCodes(index)
	RunNative("rkrelease", Null)
End Sub

'Special key combos: ctrl_shift_esc, alt_tab, ctrl_c, ctrl_v, 
'ctrl_shift_v, ctrl_z, ctrl_x, ctrl_f, ctrl_a, ctrl_shift_m, alt_f,
'meta_v, meta_c, meta_x.
'This sub takes care of the key presses and releases. 
Public Sub RobotSpecialKeyCombo(inString As String)
	Select inString
		Case "ctrl_shift_esc":
			RobotSpecialKeyPress("control")
			RobotSpecialKeyPress("shift")
			RobotSpecialKeyPress("escape")
		Case "alt_tab":
			RobotSpecialKeyPress("alt")
			RobotSpecialKeyPress("tab")
		Case "alt_f":
			RobotSpecialKeyPress("alt")
			RobotKeyPress("f")
		Case "ctrl_c":
			RobotSpecialKeyPress("control")
			RobotKeyPress("c")
		Case "meta_c":
			RobotSpecialKeyPress("meta")
			RobotKeyPress("c")
		Case "ctrl_v":
			RobotSpecialKeyPress("control")
			RobotKeyPress("v")
		Case "meta_v":
			RobotSpecialKeyPress("meta")
			RobotKeyPress("v")
		Case "ctrl_z":
			RobotSpecialKeyPress("control")
			RobotKeyPress("z")
		Case "ctrl_x":
			RobotSpecialKeyPress("control")
			RobotKeyPress("x")
		Case "meta_x":
			RobotSpecialKeyPress("meta")
			RobotKeyPress("x")
		Case "ctrl_f":
			RobotSpecialKeyPress("control")
			RobotKeyPress("f")
		Case "ctrl_shift_v":
			RobotSpecialKeyPress("control")
			RobotSpecialKeyPress("shift")
			RobotKeyPress("v")
		Case "ctrl_a":
			RobotSpecialKeyPress("control")
			RobotKeyPress("a")
		Case "ctrl_shift_m":
			RobotSpecialKeyPress("control")
			RobotSpecialKeyPress("shift")
			RobotKeyPress("m")
	End Select
	RunNative("rkreleaseAll", Null)
End Sub

Private Sub ArrayIndexOf(s As String) As Int
	For j = 0 To sKeys.Length-1
		If s==sKeys(j) Then Return j
	Next
	Return -1
End Sub

Public Sub RobotClose
	RunNative("rmend", Null)
	RunNative("rkend", Null)
End Sub

#if C
#include <Keyboard.h>
#include <Mouse.h>

void rmbegin(B4R::Object* o) 
{
	Mouse.begin();
	b4r_robo::_mmouse_left = MOUSE_LEFT;
	b4r_robo::_mmouse_right = MOUSE_RIGHT;
	b4r_robo::_mmouse_middle = MOUSE_MIDDLE;
}
void rmend(B4R::Object* o) {Mouse.end();}
void rmmove(B4R::Object* o) {Mouse.move(b4r_robo::_x,b4r_robo::_y,b4r_robo::_w);}
void rmrelease(B4R::Object* o) {Mouse.release(b4r_robo::_pressarg);}
void rmpress(B4R::Object* o) {Mouse.press(b4r_robo::_pressarg);}
void rmispressed(B4R::Object* o) {b4r_robo::_lastbool = Mouse.isPressed(b4r_robo::_pressarg);}

void rkbegin(B4R::Object* o) {Keyboard.begin();}
void rkend(B4R::Object* o) {Keyboard.end();}
void rkreleaseAll(B4R::Object* o) {Keyboard.releaseAll();}
void rkrelease(B4R::Object* o) {Keyboard.release(b4r_robo::_pressarg);}
void rkpress(B4R::Object* o) {Keyboard.press(b4r_robo::_pressarg);}
void rkprint(B4R::Object* o) {Keyboard.print((char)b4r_robo::_pressarg);}
void rkprintln(B4R::Object* o) {Keyboard.println();}
void rkwrite(B4R::Object* o) {Keyboard.write(b4r_robo::_pressarg);}

#End If